package net.rastro.superdroid;

import net.rastro.superdroid.controller.Animation;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.audio.Music;
import com.badlogic.gdx.audio.Sound;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.BitmapFont;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.utils.Array;

public class Assets {
        public static Texture background;
        public static TextureRegion backgroundRegion;

        public static TextureRegion stone;
        public static TextureRegion grass;
        public static TextureRegion dirt;
        public static TextureRegion ice;
        public static TextureRegion spikes;
        public static TextureRegion laserGun;
        public static TextureRegion laserGunRotated;
        public static TextureRegion goSign;
        public static TextureRegion goSignLeft;
        public static TextureRegion goSignUp;
        public static TextureRegion goSignDown;
        public static TextureRegion finishSign;
        public static TextureRegion rocketLauncher;    
        public static Texture	backTiles;
        public static TextureRegion	backStone;
        public static TextureRegion backDirt;
        public static Animation appleWalking;
        public static Animation appleDying;
        public static Animation bobJump;
        public static Animation	bobLadders;
        public static TextureRegion bobFall;
        public static Animation bobHit;        
        public static Animation bobIdle;
        public static Animation bobWalk;
        public static Animation bobDying;
        public static Animation coinSpinning;
        public static Animation missileAnimation;
        public static Animation explosionAnimation;
        public static Animation	liftAnimation;
        public static Animation grassDissolveAnim;
        public static Animation	dirtDissolveAnim;
        public static Animation	stoneDissolveAnim;
        public static Animation	iceDissolveAnim;
        public static TextureRegion	movingSpikeTexture;
        public static Texture	bobSprite;
        public static Texture	tiles;
        public static Texture	apple;
        public static Texture	explosion;
        public static Texture	coinTexture;
        public static Texture	starBig;
        public static TextureRegion starBigOn;
        public static TextureRegion starBigOff;
        
        public static Array<Texture> characters = new Array<Texture>();
        
        public static Texture gameLogoTexture;
        public static TextureRegion gameLogo;
        
        public static Texture	starSmall;
        public static TextureRegion starSmallOn;
        public static TextureRegion starSmallOff;
        
        public static TextureRegion	ladderTexture;
        public static Texture popupDialog;
        
        public static BitmapFont font;

        

        public static Music music;
        public static Music creditsMusic;
        public static Music menu;
        public static Sound jumpSound;
        public static Sound stoneWalk;
        public static Sound dirtWalk;
        public static Sound highJumpSound;
        public static Sound hitSound;
        public static Sound coinSound;
        public static Sound clickSound;
        public static Sound deathSound;
        public static Sound finishSound;
        public static Sound explosionSound;
        public static Sound stepWood;
        public static Sound stepIce;
        public static Sound appleSquash;

        
        public boolean isSoundOn = true;
        
        public static Texture loadTexture (String file) {
                return new Texture(Gdx.files.internal(file));
        }

        public static void load () {
                background = loadTexture("images/bg_sunflowers.png");
                backgroundRegion = new TextureRegion(background, 0, 0, 960, 640);

                characters.add( loadTexture("images/bob.png") );
                characters.add( loadTexture("images/tux.png") );
                characters.add( loadTexture("images/firefox.png") );
                characters.add( loadTexture("images/sara.png") );
                characters.add( loadTexture("images/gimp.png") );
                characters.add( loadTexture("images/gnu.png") );
                
                backTiles = loadTexture("images/backTiles.png");
                backStone = new TextureRegion(backTiles, 0, 0, 80, 80);
                backDirt = new TextureRegion(backTiles, 80, 0, 80, 80);
              
                tiles = loadTexture("images/tiles_2.png");
                stone = new TextureRegion(tiles, 0, 80, 80, 80);
                grass = new TextureRegion(tiles, 0, 160, 80, 80);
                dirt = new TextureRegion(tiles, 0, 240, 80, 80);
                spikes = new TextureRegion(tiles, 160, 0, 80, 80);
                goSign = new TextureRegion(tiles, 0, 0, 80, 80);
                goSignLeft = new TextureRegion(tiles, 240, 0, 80, 80);
                goSignUp = new TextureRegion(tiles, 320, 0, 80, 80);
                goSignDown = new TextureRegion(tiles, 400, 0, 80, 80);
                finishSign = new TextureRegion(tiles, 80, 0, 80, 80); 
                laserGun = new TextureRegion(tiles, 400, 160, 80, 80);
                laserGunRotated = new TextureRegion(tiles, 400, 240, 80, 80);
                rocketLauncher = new TextureRegion(tiles, 480, 560, 80, 80);
                ladderTexture = new TextureRegion(tiles, 480, 480, 80, 80);
                movingSpikeTexture = new TextureRegion(tiles, 480, 400, 80, 78);
                missileAnimation = new Animation(0.1f, new TextureRegion(tiles, 400, 568, 40, 73), new TextureRegion(tiles, 400, 495, 40, 73), new TextureRegion(tiles, 400, 422, 40, 73), new TextureRegion(tiles, 400, 347, 40, 73));
                liftAnimation = new Animation(0.2f, new TextureRegion(tiles, 0, 640, 160, 80), new TextureRegion(tiles, 160, 640, 160, 80));
                grassDissolveAnim = new Animation(0.15f, new TextureRegion(tiles, 0, 160, 80, 80), new TextureRegion(tiles, 80, 160, 80, 80), new TextureRegion(tiles, 160, 160, 80, 80), new TextureRegion(tiles, 240, 160, 80, 80));
                dirtDissolveAnim = new Animation(0.15f, new TextureRegion(tiles, 0, 240, 80, 80), new TextureRegion(tiles, 80, 240, 80, 80), new TextureRegion(tiles, 160, 240, 80, 80), new TextureRegion(tiles, 240, 240, 80, 80));
                stoneDissolveAnim = new Animation(0.15f, new TextureRegion(tiles, 0, 80, 80, 80), new TextureRegion(tiles, 80, 80, 80, 80), new TextureRegion(tiles, 160, 80, 80, 80), new TextureRegion(tiles, 240, 80, 80, 80));
                ice = new TextureRegion(tiles, 0, 560, 80, 80);
                iceDissolveAnim = new Animation(0.15f, new TextureRegion(tiles, 0, 560, 80, 80), new TextureRegion(tiles, 80, 560, 80, 80), new TextureRegion(tiles, 160, 560, 80, 80), new TextureRegion(tiles, 240, 560, 80, 80));
                
                apple = loadTexture("images/apple.png");
                appleWalking = new Animation(0.1f, new TextureRegion(apple, 0, 80, 80, 80), new TextureRegion(apple, 80, 80, 80, 80), new TextureRegion(apple, 160, 80, 80, 80));
                appleDying = new Animation(0.1f, new TextureRegion(apple, 0, 160, 80, 80), new TextureRegion(apple, 80, 160, 80, 80), new TextureRegion(apple, 160, 160, 80, 80),
                				new TextureRegion(apple, 0, 240, 80, 80), new TextureRegion(apple, 80, 240, 80, 80), new TextureRegion(apple, 160, 240, 80, 80));
                
                coinTexture = loadTexture("images/coin_gold.png");
                coinSpinning = new Animation(0.1f, new TextureRegion(coinTexture, 0, 0, 32, 24), new TextureRegion(coinTexture, 32, 0, 32, 24), 
                			new TextureRegion(coinTexture, 64, 0, 32, 24), new TextureRegion(coinTexture, 96, 0, 32, 24), new TextureRegion(coinTexture, 128, 0, 32, 24),
                			new TextureRegion(coinTexture, 160, 0, 32, 24),new TextureRegion(coinTexture, 192, 0, 32, 24));
                
                explosion = loadTexture("images/explosion.png");
                explosionAnimation = new Animation(0.1f, new TextureRegion(explosion, 0, 0, 20, 17), new TextureRegion(explosion, 20, 0, 20, 17), new TextureRegion(explosion, 40, 0, 20, 17), 
                						new TextureRegion(explosion, 60, 0, 20, 17), new TextureRegion(explosion, 80, 0, 20, 17), new TextureRegion(explosion,100, 0, 20, 17));
                
                popupDialog = loadTexture("images/confirm_dialog.png");
                
                
                gameLogoTexture = loadTexture("images/logo.png");
                gameLogo = new TextureRegion(gameLogoTexture, 0, 0, 300, 50);
                
                starBig = loadTexture("images/starBig.png");
                starBigOn = new TextureRegion(starBig, 0, 0, 40, 40);
                starBigOff = new TextureRegion(starBig, 40, 0, 40, 40);
                starSmall = loadTexture("images/starSmall.png");
                starSmallOn = new TextureRegion(starSmall, 0, 0, 20, 20);
                starSmallOff = new TextureRegion(starSmall, 20, 0, 20, 20);
                                            
                font = new BitmapFont(Gdx.files.internal("fonts/font.fnt"),
                        Gdx.files.internal("fonts/font.png"), false);

                music = Gdx.audio.newMusic(Gdx.files.internal("sounds/music.mp3"));
                music.setLooping(true);
                music.setVolume(SuperDroid.settings.musicVolume);
                //if (SuperDroid.settings.soundEnabled) music.play();                
                
                creditsMusic = Gdx.audio.newMusic(Gdx.files.internal("sounds/credits.mp3"));
                creditsMusic.setLooping(true);
                creditsMusic.setVolume(SuperDroid.settings.musicVolume);
                
                menu = Gdx.audio.newMusic(Gdx.files.internal("sounds/menu.mp3"));
                menu.setLooping(true);
                menu.setVolume(SuperDroid.settings.musicVolume);
                //if (SuperDroid.settings.soundEnabled) music.play();
                //creditsMusic.play();
                
                jumpSound = Gdx.audio.newSound(Gdx.files.internal("sounds/jump.ogg"));
                stoneWalk = Gdx.audio.newSound(Gdx.files.internal("sounds/stone.wav"));
                dirtWalk = Gdx.audio.newSound(Gdx.files.internal("sounds/dirt.ogg"));  
                deathSound = Gdx.audio.newSound(Gdx.files.internal("sounds/death.wav"));
                coinSound = Gdx.audio.newSound(Gdx.files.internal("sounds/coin.wav"));
                clickSound = Gdx.audio.newSound(Gdx.files.internal("sounds/click.ogg"));
                finishSound = Gdx.audio.newSound(Gdx.files.internal("sounds/round_end.wav"));
                explosionSound = Gdx.audio.newSound(Gdx.files.internal("sounds/explosion.wav"));
                stepWood = Gdx.audio.newSound(Gdx.files.internal("sounds/stepwood.wav"));
                stepIce = Gdx.audio.newSound(Gdx.files.internal("sounds/stepsnow.wav"));
                appleSquash = Gdx.audio.newSound(Gdx.files.internal("sounds/applesquash.wav"));
                /*highJumpSound = Gdx.audio.newSound(Gdx.files.internal("data/highjump.ogg"));
                hitSound = Gdx.audio.newSound(Gdx.files.internal("data/hit.ogg"));
                coinSound = Gdx.audio.newSound(Gdx.files.internal("data/coin.ogg"));
                clickSound = Gdx.audio.newSound(Gdx.files.internal("data/click.ogg"));*/
        }

        public static void playSound (Sound sound) {
                //if (SuperDroid.settings.soundEnabled) sound.play(1);
        	if(SuperDroid.settings.soundEnabled)
        	 	sound.play(SuperDroid.settings.soundEffectVolume);
        }
        
        public static void loopSound (Sound sound)
        {
        	if(SuperDroid.settings.soundEnabled)
        	 	sound.loop(SuperDroid.settings.soundEffectVolume);
        }
        
        public static void playMusic (Music music)
        {
        	music.setVolume(SuperDroid.settings.musicVolume);
        	if(SuperDroid.settings.musicEnabled)
        		music.play();        	
        }
        
        public static void loadCharacter()
        {
        	bobSprite = characters.get(SuperDroid.settings.characterID);
            bobIdle = new Animation(0.2f, new TextureRegion(bobSprite, 0, 0, 56, 80), new TextureRegion(bobSprite, 56, 0, 56, 80), new TextureRegion(bobSprite, 112, 0, 56, 80));
            bobLadders = new Animation(0.13f, new TextureRegion(bobSprite, 0, 400, 56, 80), new TextureRegion(bobSprite, 56, 400, 56, 80), new TextureRegion(bobSprite, 112, 400, 56, 80));
            bobJump = new Animation(0.2f, new TextureRegion(bobSprite, 0, 160, 56, 80), new TextureRegion(bobSprite, 56, 160, 56, 80));
            bobWalk = new Animation(0.15f, new TextureRegion(bobSprite, 0, 80, 56, 80), new TextureRegion(bobSprite, 56, 80, 56, 80), new TextureRegion(bobSprite, 112, 80, 56, 80));
            bobFall = new TextureRegion(bobSprite, 112, 160, 56, 80);
            //bobHit = new Animation(0.2f, new TextureRegion(bobSprite, 64, 128, 32, 32), new TextureRegion(bobSprite, 96, 128, 32, 32));
            bobDying = new Animation(0.2f, new TextureRegion(bobSprite, 0, 640, 56, 80), new TextureRegion(bobSprite, 56, 640, 56, 80), new TextureRegion(bobSprite, 112, 640, 56, 80));
        }
                
}
