package net.rastro.superdroid;

import java.util.Arrays;

import com.badlogic.gdx.utils.Json;
import com.badlogic.gdx.utils.Json.Serializable;
import com.badlogic.gdx.utils.OrderedMap;

public class Settings implements Serializable {
	
		
	public static boolean soundEnabled = true;
	public static int[] levelScores = new int[16];
	public static int[] levelStars = new int[16];
	public static int	levelsFinished = 0;
	public static boolean musicEnabled = true;
	public static float musicVolume = 0.5f;
	public static float soundEffectVolume = 1.0f;
	public static int 	characterID = 0;
	
	
	
	public Settings()
	{		
		Arrays.fill(levelStars, 0);
		Arrays.fill(levelScores, 0);
	}


	@Override
	public void write(Json json) {
		json.writeValue( "soundEnabled", soundEnabled );
		json.writeValue( "levelScores", levelScores );
		json.writeValue( "levelStars", levelStars );
		json.writeValue( "levelsFinished", levelsFinished );
		json.writeValue( "musicEnabled", musicEnabled );
		json.writeValue( "musicVolume", musicVolume );
		json.writeValue( "soundEffectVolume", soundEffectVolume );
		json.writeValue( "soundEffectVolume", soundEffectVolume );
		json.writeValue( "characterID", characterID );

	}


	@Override
	public void read(Json json, OrderedMap<String, Object> jsonData) {
		soundEnabled = json.readValue( "soundEnabled", boolean.class, jsonData );
		levelScores = json.readValue( "levelScores", int[].class, jsonData );
		levelStars = json.readValue( "levelStars", int[].class, jsonData );
		levelsFinished = json.readValue( "levelsFinished", int.class, jsonData );
		musicEnabled = json.readValue( "musicEnabled", boolean.class, jsonData );
		musicVolume = json.readValue( "musicVolume", float.class, jsonData );
		soundEffectVolume = json.readValue( "soundEffectVolume", float.class, jsonData );
		characterID = json.readValue( "characterID", int.class, jsonData );

	}
		
}
