package net.rastro.superdroid.model;

import com.badlogic.gdx.math.Rectangle;
import com.badlogic.gdx.math.Vector2;

public class Block {

	public static final float SIZEX = 1f;
	public static final float SIZE = 1f;	
	public static final float dissolveTime = 0.6f;
	
	public static final int STONE = 0;
	public static final int GRASS = 1;
	public static final int DIRT = 2;
	public static final int SPIKES = 3;
	public static final int GRASS_DISOLVE = 4;
	public static final int DIRT_DISSOLVE = 5;
	public static final int STONE_DISSOLVE = 6;
	public static final int ICE = 7;
	public static final int ICE_DISSOLVE = 8;

	Vector2 	position = new Vector2();
	Rectangle 	bounds = new Rectangle();
	int	type = 0;
	float SIZEY = 1f;
	float stateTime = 0f;
	boolean isActive=true;	
	boolean doDissolve = false;

	public Block(Vector2 pos, int stype) {
		this.position = pos;
		if(stype==SPIKES)
		{
			SIZEY = 0.5f;
		}
		else
		{
			SIZEY= 1f;
		}
			this.bounds = new Rectangle(pos.x, pos.y, SIZEX, SIZEY);		
		this.type = stype;
	}
	
	public Vector2 getPosition() {
		return position;
	}

	public Rectangle getBounds() {
		return bounds;
	}	
	
	public float getSizeY()
	{
		return SIZEY;
	}
	
	public int getType() {
		return type;
	}
	
	public float getStateTime()
	{
		return stateTime;
	}
	
	public void dissolve()
	{
		doDissolve = true;
	}
	
	public boolean doIDissolve()
	{
		return doDissolve;
	}
	
	public boolean amIActive()
	{
		return isActive;
	}
	
	public void updateBlock(float delta)
	{			
		if(!doDissolve) return;
		stateTime += delta;
		if(stateTime >= dissolveTime) isActive = false;		
	}
	
	public void resetBlock()
	{
		stateTime = 0f;
		isActive = true;
		doDissolve = false;
	}
}