package net.rastro.superdroid.model;


import com.badlogic.gdx.math.Rectangle;
import com.badlogic.gdx.math.Vector2;

public class Bob {

	
	public static final int IDLE = 0;
    public static final int WALKING = 1;
    public static final int JUMPING = 2;
    public static final int DYING = 3;
    public static final int FALLING = 4;
    public static final int HITTING = 5;
    public static final int WALKING_LADDER = 6;

    public float	dieTimeElapsed=0;

	public static final float SPEED = 3f;	// unit per second
	public static final float JUMP_VELOCITY = 6.2f;
	public static float jump_speed = 0f;	
	public static final float BOB_HEIGHT = 0.9f; // half a unit
	public static final float BOB_WIDTH = 0.9f; // half a unit
	
	public static  float spawnX = 1f;
	public static  float spawnY = 10f;
	
	public boolean secondJump = false;
	
	public static float stateTime;


	Vector2 	position = new Vector2();	
	Vector2 	acceleration = new Vector2();
	Vector2 	velocity = new Vector2();
	Rectangle 	bounds = new Rectangle();
	public static int		state = IDLE;
	public static boolean		facingLeft = false;
	public boolean		isFalling = false;
	boolean		isGround = false;
	boolean isLadder = false;
	boolean amIWalking = false;
	boolean		amIRidingLift = false;
	boolean		imOnIce = false;

	public Bob(Vector2 position) {
		this.position = position;		
		this.bounds = new Rectangle(position.x , position.y, BOB_WIDTH, BOB_HEIGHT);
		stateTime=0;
	}
	
	public Rectangle getBounds() {
		return bounds;
	}
	
	public Vector2 getPosition() {
		return position;
	}
		

	public void setState(int newState) {
		state = newState;
	}

	public void update(float delta) {
		//System.out.println(spawnPosition);
		//System.out.println(this.position);
		if(this.amIRidingLift)
		{
			isGround=true;	
			isFalling = false;			
		}
		if(this.state != DYING)
		{
			if(this.state == WALKING_LADDER || this.isLadder)
			{
				isGround=true;	
				isFalling = false;
				//System.out.println("LADDER HIT- BOB Y SPEED: " + this.velocity.y);
			}			
			
			
			if(this.state == JUMPING || this.state == FALLING)
			{
				//System.out.println("I dont make sense");
				if(isGround && isFalling)
				{
					state = IDLE;
					isFalling = false;
					velocity.y = 0;
					secondJump = false;
				}
				else
				{				
					this.jump_speed -= this.JUMP_VELOCITY*delta;
					isFalling = true;
					if(this.jump_speed <= 0) state = FALLING;
					velocity.y = this.jump_speed;
				}
			}		
			if(imOnIce)
			{				
				if(state == IDLE && velocity.x < 0)
					velocity.x += 0.02f;
				if(state == IDLE && velocity.x > 0)
					velocity.x -= 0.02f;
			}			
			position.add(velocity.tmp().mul(delta));
			this.bounds = new Rectangle(position.x , position.y, BOB_WIDTH, BOB_HEIGHT);
		}
		else if(!isGround)
		{
			//System.out.println("I bet you didnt expect me: " + isGround);			
			if(isGround && isFalling)
			{				
				isFalling = false;
				velocity.y = 0;
			}
			else
			{				
				this.jump_speed -= this.JUMP_VELOCITY*delta;	
				isFalling=true;
				velocity.y = this.jump_speed;
			}
			velocity.x -= 0.1f*delta;
			System.out.println(velocity.x);
			if(velocity.x <= 0f) velocity.x=0f;
			position.add(velocity.tmp().mul(delta));
			this.bounds = new Rectangle(position.x , position.y, BOB_WIDTH, BOB_HEIGHT);
		}
		stateTime += delta;
	}

	public void setFacingLeft(boolean b) {
		facingLeft = b;
		
	}

	public Vector2 getVelocity() {
		
		return velocity;
	}

	public Vector2 getAcceleration() {
		return acceleration;
	}
	
	public void setFalling(boolean b)
	{
		isFalling = b;
	}
	
	public void setGround(boolean b)
	{
		isGround = b;
	}

	public int getState() {
		// TODO Auto-generated method stub
		return this.state;
	}

	public void resetPosition() {
		// TODO Auto-generated method stub
		//System.out.println(spawnPosition);
		position.set(spawnX, spawnY);
		dieTimeElapsed=0;
		this.bounds = new Rectangle(position.x , position.y, BOB_WIDTH, BOB_HEIGHT);
		stateTime=0;
	}
	
	public void setLadder(boolean b)
	{
		this.isLadder = b;
	}
	
	public boolean getLadder()
	{
		return this.isLadder;
	}
	
	public boolean isBobWalking()
	{
		return amIWalking;	
	}
	public void setBobWalking(boolean bb)
	{
		amIWalking = bb;	
	}
	public void setRidingLift(boolean b)
	{
		this.amIRidingLift = b;
	}
	public boolean isBobRidingLift()
	{
		return amIRidingLift;	
	}
	
	public void iceIceBaby(boolean b)
	{
		imOnIce = b;
	}
	
	public boolean esSlidejuPaSlidotavu()
	{
		return imOnIce;
	}

}