package net.rastro.superdroid.model;

import net.rastro.superdroid.Assets;
import net.rastro.superdroid.controller.overlapTest;

import com.badlogic.gdx.math.Rectangle;
import com.badlogic.gdx.math.Vector2;

public class Coin {

	public static final float SIZE = 0.7f;
	public float stateTime = 0;

	Vector2 	position = new Vector2();
	Rectangle 	bounds = new Rectangle();
	boolean		active=true;	

	public Coin(Vector2 pos) {
		this.position = pos;
		this.bounds = new Rectangle(pos.x, pos.y, SIZE, SIZE);		
	}
	
	public void update(float delta, Rectangle bobBounds)
	{
		stateTime+=delta;
		if(overlapTest.overlapRectangles(bobBounds, bounds))
		{
			//System.out.println("Coin touched");
			this.active = false;
			World.coinsCollected++;
			Assets.playSound(Assets.coinSound);
		}
	}
	
	public boolean isActive()
	{
		return active;
	}
	
	public Vector2 getPosition() {
		return position;
	}

	public Rectangle getBounds() {
		return bounds;
	}	
}