package net.rastro.superdroid.model;

import net.rastro.superdroid.controller.overlapTest;

import com.badlogic.gdx.math.Rectangle;
import com.badlogic.gdx.math.Vector2;

public class Ladder {

	public static final float SIZE = 1f;
	public float stateTime = 0;

	Vector2 	position = new Vector2();
	Rectangle 	bounds = new Rectangle();
	boolean		imTouched=false;	

	public Ladder(Vector2 pos) {
		this.position = pos;
		this.bounds = new Rectangle(pos.x+0.3f, pos.y, SIZE-0.6f, SIZE);		
	}
	
	public void update(Rectangle bobBounds)
	{		
		if(overlapTest.overlapRectangles(bobBounds, bounds))
		{
			//System.out.println("Ladder touched");
			this.imTouched = true;
			//World.LaddersCollected++;
			//Assets.LadderSound.play();
		}
		else
			this.imTouched=false;
	}
	
	public boolean isTouched()
	{
		return imTouched;
	}
	
	public Vector2 getPosition() {
		return position;
	}

	public Rectangle getBounds() {
		return bounds;
	}	
}