package net.rastro.superdroid.model;

import com.badlogic.gdx.math.Rectangle;
import com.badlogic.gdx.math.Vector2;

public class Laser {

	public static final float SIZE = 1f;
	public static final int GROUND = 1;
	public static final int CEILING = 2;
	public static final int LEFT = 3;
	public static final int RIGHT = 4;
	public static final float activeTime = 2f;

	Vector2 	position = new Vector2();
	Rectangle 	bounds = new Rectangle();
	int laserType;
	float laserLength;
	private boolean pulsing = false;
	private float pulse=0;
	private boolean active=true;

	public Laser(Vector2 pos, boolean pulsating) {
		this.position = pos;		
		pulsing = pulsating;
		this.bounds = new Rectangle(pos.x, pos.y, SIZE, SIZE);		
	}
	
	public void update(float delta)
	{
		if(!pulsing) return;
		this.pulse+=delta;
		//pulsate the laser
		if(this.pulse >= activeTime)
		{
			this.pulse = 0;
			this.active = !this.active;			
		}			
	}
	public void setType(int type)
	{
		laserType=type;
	}
	public void setLength(float length)
	{
		laserLength = length;
	}
	
	public float getLength()
	{
		return laserLength;
	}
	
	public boolean isActive()
	{
		return active;
	}
	
	public int getType()
	{
		return laserType;
	}
	
	public Vector2 getPosition() {
		return position;
	}

	public Rectangle getBounds() {
		return bounds;
	}	
}