package net.rastro.superdroid.model;

import net.rastro.superdroid.controller.overlapTest;

import com.badlogic.gdx.math.Rectangle;
import com.badlogic.gdx.math.Vector2;

public class Lift {

	public static final float SIZE_W = 2f;
	public static final float SIZE_H = 1f;
	public static final float SPEED = 3f;
	private float stateTime = 0;

	Vector2 	position = new Vector2();
	Vector2		startPos = new Vector2();
	Vector2		endPos = new Vector2();
	Vector2 	velocity = new Vector2();
	Rectangle 	bounds = new Rectangle();
	boolean		goingUP=true;	
	boolean		isBobRiding = false;
	Rectangle tempRect = new Rectangle();

	public Lift(Vector2 startPos, Vector2 endPos) {
		this.position.set(startPos);
		this.startPos.set(startPos);
		this.endPos.set(endPos);
		this.velocity.set(0f,this.SPEED);
		this.bounds = new Rectangle(startPos.x, startPos.y, SIZE_W, SIZE_H);		
	}
	
	public void update(float delta, Rectangle bobBounds)
	{
		stateTime+=delta;		
		
		if(this.position.y >= this.endPos.y && goingUP)
		{
			goingUP = false;
			this.velocity.y=-this.SPEED;			
		}
		if(this.position.y <= this.startPos.y && !goingUP)
		{
			goingUP = true;
			this.velocity.y=this.SPEED;		
		}
		tempRect = new Rectangle(position.x, position.y, SIZE_W, SIZE_H-0.7f); 		
		if(overlapTest.overlapRectangles(bobBounds, tempRect))
		{
			goingUP = true;
			this.velocity.y=this.SPEED;	
		}
		
		
		position.add(velocity.tmp().mul(delta));
		this.bounds = new Rectangle(position.x , position.y, SIZE_W, SIZE_H);		
		//System.out.println("Lift position: " + this.position);
				
		tempRect = new Rectangle(position.x+0.4f, position.y+0.7f, SIZE_W-0.4f, SIZE_H-0.7f); 		
		if(overlapTest.overlapRectangles(bobBounds, tempRect))
		{
			//System.out.println("Lift top touched");
			isBobRiding = true;
		}
		else
			isBobRiding = false;
	}
	
	public boolean isGoingUP()
	{
		return goingUP;
	}
	
	public Vector2 getPosition() {
		return position;
	}

	public Rectangle getBounds() {
		return bounds;
	}	
	
	public boolean isBobRiding() {
		return isBobRiding;
	}
	
	public float getTime()
	{
		return stateTime;
	}
	
	public void resetPosition()
	{
		this.position.set(startPos);
	}
}