package net.rastro.superdroid.model;

import net.rastro.superdroid.controller.overlapTest;

import com.badlogic.gdx.math.Rectangle;
import com.badlogic.gdx.math.Vector2;

public class MovingSpike {

	public static final float SIZE = 1f;
	public static final float SPEED_DOWN = 6f;
	public static final float SPEED_UP = 3f;
	private float stateTime = 0;

	Vector2 	position = new Vector2();
	Vector2		startPos = new Vector2();
	Vector2		endPos = new Vector2();
	Vector2 	velocity = new Vector2();
	Rectangle 	bounds = new Rectangle();
	boolean		goingUP=false;	
	boolean 	hitBob=false;
	
	public MovingSpike(Vector2 startPos, Vector2 endPos) {
		this.position.set(startPos);
		this.startPos.set(startPos);
		this.endPos.set(endPos);
		this.velocity.set(0f,-this.SPEED_DOWN);
		this.bounds = new Rectangle(startPos.x, startPos.y, SIZE, SIZE);		
	}
	
	public void update(float delta, Rectangle bobBounds)
	{
		stateTime+=delta;		
		
		if(this.position.y >= this.startPos.y && goingUP)
		{
			goingUP = false;
			this.velocity.y=-this.SPEED_DOWN;			
		}
		if(this.position.y <= this.endPos.y && !goingUP)
		{
			goingUP = true;
			this.velocity.y=this.SPEED_UP;		
		}
		
		
		position.add(velocity.tmp().mul(delta));
		this.bounds = new Rectangle(position.x , position.y, SIZE, SIZE);		
		//System.out.println("MovingSpike position: " + this.position + " " + endPos + " " + startPos);
				
		Rectangle tempRect = new Rectangle(position.x+0.3f, position.y+0.3f, SIZE-0.6f, SIZE-0.6f);
		if(overlapTest.overlapRectangles(bobBounds, tempRect ))
		{
			//System.out.println("MovingSpike top touched");
			hitBob=true;
		}
		
	}
	
	public boolean isGoingUP()
	{
		return goingUP;
	}
	
	public Vector2 getPosition() {
		return position;
	}

	public Rectangle getBounds() {
		return bounds;
	}	
	
	public float getTime()
	{
		return stateTime;
	}
	
	public void resetPosition()
	{
		this.position.set(startPos);
		this.hitBob = false;
	}
	public boolean didIHitBob()
	{
		return hitBob;
	}
}