package net.rastro.superdroid.screens;

import net.rastro.superdroid.Assets;
import net.rastro.superdroid.SuperDroid;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.BitmapFont;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.actions.FadeIn;
import com.badlogic.gdx.scenes.scene2d.actions.Sequence;
import com.badlogic.gdx.scenes.scene2d.ui.ClickListener;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.scenes.scene2d.ui.Skin;
import com.badlogic.gdx.scenes.scene2d.ui.TextButton;
import com.badlogic.gdx.scenes.scene2d.ui.tablelayout.Table;
import com.badlogic.gdx.scenes.scene2d.ui.tablelayout.TableLayout;
import com.badlogic.gdx.utils.Scaling;


public class CreditScreen extends
AbstractScreen
 {


	private Texture texture;
	private Texture libgdxLogo;
    private Image img;
    private Image libgdxLogoImg;
    private Image logoImage;
    private Table table;
    private Table tableButtons;
    
    
    
	public CreditScreen(
	        SuperDroid game )
	    {
	        super( game );
	    }




	@Override
	public void show() {
		// TODO Auto-generated method stub				
		Skin skin = super.getSkin();
		Gdx.input.setInputProcessor(stage);
		
        texture = new Texture(Gdx.files.internal("images/background.jpg"));
        libgdxLogo = new Texture(Gdx.files.internal("images/libgdx.png"));
        // set the linear texture filter to improve the image stretching
       // texture.setFilter( TextureFilter.Linear, TextureFilter.Linear );
        Assets.menu.stop();
        Assets.music.stop();
        Assets.playMusic(Assets.creditsMusic);

        font = new BitmapFont(Gdx.files.internal("fonts/font.fnt"), false);          
                
          //ui = new Stage(width, height, true);
          img = new Image(new TextureRegion(texture), Scaling.stretch );
          img.x = 0;
          img.y = 0;
          img.width = stage.width();
          img.height = stage.height();   
          
       // this is needed for the fade-in effect to work correctly; we're just
          // making the image completely transparent          

          // configure the fade-in/out effect on the splash image
                   
          //stage.addActor(img);
          table = new Table( skin );
          table.width = stage.width();
          table.height = stage.height();
          
          tableButtons = new Table( skin );
          tableButtons.width = stage.width();
          tableButtons.height = stage.height();
          
          table.color.a = 0f;
          tableButtons.color.a = 0f;
          img.color.a = 0f;
          
          
          logoImage = new Image(Assets.gameLogo, Scaling.stretch);
          logoImage.y = stage.height()-logoImage.height-10f;
          logoImage.x = 10f;
          logoImage.color.a = 0f;
          Sequence logoFadeIn = Sequence.$( FadeIn.$( 0.75f ));
          logoImage.action( logoFadeIn );
          
          
          Sequence actionIMG = Sequence.$( FadeIn.$( 0.50f ));
          Sequence actionTable = Sequence.$( FadeIn.$( 0.50f ));
          Sequence actionTableButtons = Sequence.$( FadeIn.$( 0.75f ));
          table.action( actionTable );  
          img.action( actionIMG );           
          tableButtons.action( actionTableButtons );
          
          stage.addActor(img);          
          stage.addActor( table );
          stage.addActor(tableButtons);
          stage.addActor( logoImage );
          
          TableLayout btnLayout = tableButtons.getTableLayout(); 
          btnLayout.row();
          
          TextButton backToMenuBtn = new TextButton( "Back To Main Menu", skin );
          backToMenuBtn.setClickListener( new ClickListener() {
              @Override
              public void click(
                  Actor actor,
                  float x,
                  float y )
              {
            	  System.out.println("back clicked");
            	  Assets.playSound(Assets.clickSound);
            	  Assets.creditsMusic.stop();
            	  //Assets.playMusic(Assets.music);
                  game.setScreen( new MainMenu(game) );                 
              }
          } ); 
      	  btnLayout.add( backToMenuBtn ).width(180);
      	  
      	  btnLayout.bottom().left();
          
          // retrieve the table's layout
          table.add( "CREDITS" ).padBottom(20).colspan(3);
          table.row();
          
          table.add( "Developed by Raivis Strogonovs" );
          table.row();
          table.add( "Resources:" ).padTop(50);
          table.row();
          table.add("Matt Hackett of Lost Decade Games");
          table.row();
          table.add("http://opengameart.org");
          table.row();
          table.add("Play this game online").padTop(50);
          table.row();
          table.add("or download it for your PC at");
          table.row();
          table.add("official home page: http://morf.lv").padTop(5);
          table.row();          
          
          libgdxLogoImg = new Image(new TextureRegion(libgdxLogo), Scaling.stretch );
          table.add(libgdxLogoImg);
          
          table.center();
          
                                    
		
	}   
}