package net.rastro.superdroid.screens;

import net.rastro.superdroid.SuperDroid;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.BitmapFont;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.scenes.scene2d.Action;
import com.badlogic.gdx.scenes.scene2d.OnActionCompleted;
import com.badlogic.gdx.scenes.scene2d.actions.Delay;
import com.badlogic.gdx.scenes.scene2d.actions.FadeIn;
import com.badlogic.gdx.scenes.scene2d.actions.FadeOut;
import com.badlogic.gdx.scenes.scene2d.actions.Sequence;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.utils.Scaling;


public class SplashScreen extends
AbstractScreen
 {


	private Texture texture;
    private Image img;
    
    
	public SplashScreen(
	        SuperDroid game )
	    {
	        super( game );
	    }




	@Override
	public void show() {
		// TODO Auto-generated method stub		
		Gdx.input.setInputProcessor(stage);
        texture = new Texture(Gdx.files.internal("images/splash.png"));
        // set the linear texture filter to improve the image stretching
       // texture.setFilter( TextureFilter.Linear, TextureFilter.Linear );        
        
        font = new BitmapFont(Gdx.files.internal("fonts/font.fnt"), false);          
                
          //ui = new Stage(width, height, true);
          img = new Image(new TextureRegion(texture), Scaling.stretch );
          img.x = 0;
          img.y = 0;
          img.width = stage.width();
          img.height = stage.height();   
          
       // this is needed for the fade-in effect to work correctly; we're just
          // making the image completely transparent
          img.color.a = 0f;

          // configure the fade-in/out effect on the splash image
          Sequence actions = Sequence.$( FadeIn.$( 0.75f ), Delay.$( FadeOut.$( 0.75f ), 1.75f ) );
          
          actions.setCompletionListener(new OnActionCompleted() {
              @Override
              public void completed(
                  Action action )
              {
                  // when the image is faded out, move on to the next screen
                  //game.setScreen( new GameScreen() );
            	  game.setScreen(new MainMenu(game));
              }
          } );
          
          img.action( actions );
          stage.addActor(img);                             
		
	}   
}