package net.rastro.superdroid.view;

import net.rastro.superdroid.model.World;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;
import com.badlogic.gdx.graphics.g2d.TextureRegion;

public class LoadingScreen {
        World map;
        SpriteBatch batch;
        TextureRegion loadingPic;

        private int ww;
        private int hh;
        public boolean loadingReady = false;
        public boolean loadingDone = false;

        public LoadingScreen () {                            
        }
        
        public void setwwHH(int width, int height)
        {
        	ww=width;
        	hh=height;
        	loadAssets();
        	loadingReady = true;
        }

        private void loadAssets () {
                Texture texture = new Texture(Gdx.files.internal("images/loading_screen.png"));
                loadingPic = new TextureRegion(texture, 0, 0, 1280, 800);
                batch = new SpriteBatch();
                batch.getProjectionMatrix().setToOrtho2D(0, 0, ww, hh);//480x320
        }

        public void render () {
                //if (Gdx.app.getType() != ApplicationType.Android) return;
                
                batch.disableBlending();
                batch.begin();
                batch.draw(loadingPic,0, 0, ww, hh);
                batch.end();
        }

        public void dispose () {
        		loadingPic.getTexture().dispose();
                batch.dispose();        
                loadingDone = true;
        }
}

